

MainLine2Yard(DetectorID, EngineNo, TagLocation, CarModel, YOUNGSTOWN_YARD1_BLOCK, YOUNGSTOWN_YARD2_BLOCK, YOUNGSTOWN_YARD, EndBlockNo)
	
function MainLine2Yard(DetectorID, EngineNo, TagLocation, CarModel, Yard1, Yard2, SwitchName, StopBlock)
	if (EngineNo == MyEngineNo and TagLocation == TAG_ON_FRONT_TRUCK) then		-- if MyEngineNo in tag
		print(DetectorID .. "Engine " .. MyEngineNo .. " detected");
		print(BlockName[LastBlockNo] .. " > " .. BlockName[CurrentBlockNo] .. " > " .. BlockName[NextBlockNo]);
		CurrentBlockNo = NextBlockNo;
		-- check for occupancy clear Yard2 or Yard1 - Ending block must be unoccupied otherwise fail
		NextBlockNo = StopBlock;	-- ending block number
		if (GetOccupancy(NextBlockNo) ~= 0) then
			return Stop(BlockName[NextBlockNo] .. " occupied");
			end
		print(BlockName[NextBlockNo] .. " occupancy flag value = ".. GetOccupancy(NextBlockNo));

		print(DetectorID .. "Next Block Selection = " .. BlockName[NextBlockNo]);
		-- set SwitchName switch
		if (NextBlockNo == Yard1) then
			Switch(NORMAL, Switches[SwitchName][CHAN_NUMBER], Switches[SwitchName][AIU_NUMBER], Switches[SwitchName][TIU_NUMBER], 0);
			end;
		if (NextBlockNo == Yard2) then
			Switch(REVERSE, Switches[SwitchName][CHAN_NUMBER], Switches[SwitchName][AIU_NUMBER], Switches[SwitchName][TIU_NUMBER], 0);
			end;		
		SetOccupancy(NextBlockNo, MyEngineNo);	-- set occupancy flag in Yard2 or Yard1
		WaitforCaboose40 = true;
		end;
	if (EngineNo == 0 and CarModel == CABOOSE and WaitforCaboose40) then
		print(DetectorID .. "Caboose detected");
		--print(DetectorID .. "Caboose - Last Block = " .. BlockName[LastBlockNo]);
		if (LastBlockNo ~= 0) then
			ClearOccupancy(LastBlockNo);	-- clear LastBlockNo occupancy
			end;
		LastBlockNo = CurrentBlockNo;
		WaitforCaboose40 = false;
		print(BlockName[LastBlockNo] .. " > " .. BlockName[CurrentBlockNo] .. " > " .. BlockName[NextBlockNo]);
		print(DetectorID .. "Next Block = ".. BlockName[NextBlockNo] .. " when leaving"); 
		end;
end