Passing2MainLine(DetectorID, EngineNo, TagLocation, CarModel, J_L_THRU_TRACK, J_L_PASSING_TRACK, ALIQUIPPA_WEST, ALIQUIPPA_BLOCK)


function Passing2MainLine(DetectorID, EngineNo, TagLocation, CarModel, Normal_Track, Reverse_Track, SwitchName, Block)
-- uses globals: MyEngineNo, LastBlockNo, CurrentBlockNo, NextBlockNo

	if (EngineNo == MyEngineNo and TagLocation == TAG_ON_FRONT_TRUCK) then	-- if MyEngineNo in tag
		print(DetectorID .. "Engine " .. MyEngineNo .. " detected");
		print(BlockName[LastBlockNo] .. " > " .. BlockName[CurrentBlockNo] .. " > " .. BlockName[NextBlockNo]);
		CurrentBlockNo = NextBlockNo;
		if (GetOccupancy(Block) ~= 0) then	-- check for occupancy clear Block
			-- if not clear, schedule stop in CurrentBlockNo
			-- debug
			StopDelay = CalculateStopDelay(CurrentBlockNo, MyEngineNo, MyDirection, MyEngineSpeed)
			-- debug
			SetSpeed(0, StopDelay, MyEngineNo, MyTIUNo);	-- Stop delay
			end;
		WaitforCaboose51 = true;
		end;
	if (EngineNo == 0 and CarModel == CABOOSE and WaitforCaboose51) then
		print(DetectorID .. "Caboose detected");
		--print(DetectorID .. "Caboose - Last Block = " .. BlockName[LastBlockNo]);
		-- wait for Block to be unoccupied, set SwitchName switch
		Sleep(5);	-- give the caboose time to clear the switch
		ClearOccupancy(LastBlockNo);	-- clear LastBlockNo occupancy		
		SetOccupancy(Block, MyEngineNo);	-- set occupancy flag in Block
		NextBlockNo = Block;	-- set NextBlockNo to Block,
		-- set SwitchName switch
		if (CurrentBlockNo == Normal_Track) then
			Switch(NORMAL, Switches[SwitchName][CHAN_NUMBER], Switches[SwitchName][AIU_NUMBER], Switches[SwitchName][TIU_NUMBER], 0);
			end;
		if (CurrentBlockNo == Reverse_Track) then
			Switch(REVERSE, Switches[SwitchName][CHAN_NUMBER], Switches[SwitchName][AIU_NUMBER], Switches[SwitchName][TIU_NUMBER], 0);
			end;		
		SetSpeed(MyEngineSpeed, 0, MyEngineNo, MyTIUNo);	-- start moving if stopped
		LastBlockNo = CurrentBlockNo;
		WaitforCaboose51 = false;
		print(BlockName[LastBlockNo] .. " > " .. BlockName[CurrentBlockNo] .. " > " .. BlockName[NextBlockNo]);
		print(DetectorID .. "Next Block = ".. BlockName[NextBlockNo] .. " when leaving"); 
		end;

end;