MainLine2Passing("@ 3-0 ", EngineNo, TagLocation, CarModel, J_L_THRU_TRACK, J_L_PASSING_TRACK, ALIQUIPPA_EAST    )


function MainLine2Passing(DetectorID, EngineNo, TagLocation, CarModel, Normal_Track, Reverse_Track, SwitchName)
-- uses globals: MyEngineNo, LastBlockNo, CurrentBlockNo, NextBlockNo
if (EngineNo == MyEngineNo and TagLocation == TAG_ON_FRONT_TRUCK) then		-- if MyEngineNo in tag
	print(DetectorID .. "Engine " .. MyEngineNo .. " detected");
	print(BlockName[LastBlockNo] .. " > " .. BlockName[CurrentBlockNo] .. " > " .. BlockName[NextBlockNo]);
	CurrentBlockNo = NextBlockNo;
	-- check for occupancy clear Reverse_Track or Normal_Track - one or the other must be unoccupied otherwise fail
	if (GetOccupancy(Reverse_Track) ~= 0 and GetOccupancy(Normal_Track) ~= 0) then
		return Stop(DetectorID .. BlockName[Reverse_Track] .. " and " .. BlockName[Normal_Track] .. " are both occupied");
		end
	print(BlockName[Normal_Track] .. " occupancy flag value = ".. GetOccupancy(Normal_Track));
	-- choose based on superiority or choose empty block
	if (MyDirection == SuperiorDirection) then
		if (GetOccupancy(Normal_Track) == 0) then
			NextBlockNo = Normal_Track;		-- Westbound trains are superior, take the through track if possible
			else
			NextBlockNo = Reverse_Track;
			end;
		else	-- MyDirection ~= SuperiorDirection
		if (GetOccupancy(Reverse_Track) == 0) then
			NextBlockNo = Reverse_Track;	-- Westbound trains are superior, take the passing track if possible
			else
			NextBlockNo = Normal_Track;
			end;
		end
	print(DetectorID .. "Next Block Selection = " .. BlockName[NextBlockNo]);
	-- set SwitchName switch
	if (NextBlockNo == Normal_Track) then
		Switch(NORMAL, Switches[SwitchName][CHAN_NUMBER], Switches[SwitchName][AIU_NUMBER], Switches[SwitchName][TIU_NUMBER], 0);
		end;
	if (NextBlockNo == Reverse_Track) then
		Switch(REVERSE, Switches[SwitchName][CHAN_NUMBER], Switches[SwitchName][AIU_NUMBER], Switches[SwitchName][TIU_NUMBER], 0);
		end;		
	SetOccupancy(NextBlockNo, MyEngineNo);	-- set occupancy flag in Reverse_Track or Normal_Track
	WaitforCaboose30 = true;
	end;
if (EngineNo == 0 and CarModel == CABOOSE and WaitforCaboose30) then
	print(DetectorID .. "Caboose detected");
	--print(DetectorID .. "Caboose - Last Block = " .. BlockName[LastBlockNo]);
	if (LastBlockNo ~= 0) then
		ClearOccupancy(LastBlockNo);	-- clear LastBlockNo occupancy
		end;
	LastBlockNo = CurrentBlockNo;
	WaitforCaboose30 = false;
	print(BlockName[LastBlockNo] .. " > " .. BlockName[CurrentBlockNo] .. " > " .. BlockName[NextBlockNo]);
	print(DetectorID .. "Next Block = " .. BlockName[NextBlockNo] .. " when leaving"); 
	end;
end;